<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>

    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />

    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css" />
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

    <style>
        th {
            background-color: #5b9ad4;
            color: white;
        }

        table {
            background-color: #d3dfef;
        }

        tr:nth-child(even) {
            background-color: #eaeef6;
        }

        th,
        td {
            border: 1px solid white;
        }
    </style>
</head>

<body>
    <div class="container-fluid">
        <h3 class="text-center my-3">DANH SÁCH SẢN PHẨM</h3>
        <div class="jumbotron mb-3">
            <div class="row">
                <div class="col-md-5">
                    <div class="row">
                        <div class="col-md-3 px-0 text-right">
                            <label>Quốc gia</label>
                        </div>
                        <div class="col-md-9">
                            <select name="" id="nuoc-select" class="form-control">
                                <option value="0">-- Chọn quốc gia --</option>
                            </select>
                        </div>
                    </div>
                </div>

                <div class="col-md-5">
                    <div class="row">
                        <div class="col-md-4 px-0 text-right">
                            <label>Nhóm sản phẩm</label>
                        </div>
                        <div class="col-md-8">
                            <select name="" id="nhom-san-pham-select" class="form-control">
                                <option value="0">-- Chọn nhóm sản phẩm --</option>
                            </select>
                        </div>
                    </div>
                </div>
                <div class="col-md-2">
                    <button class="btn btn-success" id="btn-filter">Lọc sản phẩm</button>
                </div>
            </div>
        </div>

        <button class="btn btn-success mb-2">+ Thêm sản phẩm</button>

        <table class="table" id="san-pham-table">
            <thead>
                <th scope="col">STT</th>
                <th scope="col">Mã sản phẩm</th>
                <th scope="col">Tên sản phẩm</th>
                <th scope="col">Nhóm sản phẩm</th>
                <th scope="col">Quốc gia</th>
                <th scope="col">Ảnh đại diện</th>
                <th scope="col">Giá bán</th>
                <th scope="col">Giá giảm</th>
                <th scope="col">Action</th>
            </thead>
            <tbody></tbody>
        </table>

        <table class="table" id="filter-table" style="display: none;">
            <thead>
                <th scope="col">STT</th>
                <th scope="col">Mã sản phẩm</th>
                <th scope="col">Tên sản phẩm</th>
                <th scope="col">Nhóm sản phẩm</th>
                <th scope="col">Quốc gia</th>
                <th scope="col">Ảnh đại diện</th>
                <th scope="col">Giá bán</th>
                <th scope="col">Giá giảm</th>
                <th scope="col">Action</th>
            </thead>
            <tbody></tbody>
        </table>
    </div>

    <!-- Edit Modal -->
    <div id="edit-product-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-tittle">Sửa thông tin sản phẩm</h5>
                    <button class="close" data-dismiss="modal">&times;</button>
                </div>

                <div class="modal-body">
                    <div class="row py-3">
                        <img src="" id="img-modal" style="
                            width: 9rem;
                            height: 7rem;
                            margin-left: auto;
                            margin-right: auto;
                            border:1px solid #5b9ad4;
                        " />
                    </div>
                    <form action="">
                        <div class="row form-group">
                            <label class="col-form-label col-sm-4">Link ảnh</label>
                            <div class="col-sm-8">
                                <input type="text" id="input-edit-img-url" class="form-control" />
                            </div>
                        </div>
                        <div class="row form-group">
                            <label class="col-form-label col-sm-4">Mã sản phẩm</label>
                            <div class="col-sm-8">
                                <input type="text" id="input-edit-masp" class="form-control" />
                            </div>
                        </div>
                        <div class="row form-group">
                            <label class="col-form-label col-sm-4">Tên sản phẩm</label>
                            <div class="col-sm-8">
                                <input type="text" id="input-edit-tensp" class="form-control" />
                            </div>
                        </div>
                        <div class="row form-group">
                            <label class="col-form-label col-sm-4">Giá bán</label>
                            <div class="col-sm-8">
                                <input type="text" id="input-edit-gia-ban" class="form-control" />
                            </div>
                        </div>
                        <div class="row form-group">
                            <label class="col-form-label col-sm-4">Giá giảm</label>
                            <div class="col-sm-8">
                                <input type="text" id="input-edit-gia-giam" class="form-control" />
                            </div>
                        </div>

                        <div class="row form-group">
                            <label class="col-form-label col-sm-4">Nhóm sản phẩm</label>
                            <div class="col-sm-8">
                                <select name="" id="select-edit-category" class="form-control">
                                </select>
                            </div>
                        </div>
                        <div class="row form-group">
                            <label class="col-form-label col-sm-4">Quốc gia</label>
                            <div class="col-sm-8">
                                <select name="" id="select-edit-country" class="form-control">
                                </select>
                            </div>
                        </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <button class="btn btn-primary" id="btn-edit-product">Sửa</button>
                    <button class="btn btn-secondary" data-dismiss="modal">Hủy</button>
                </div>
            </div>
        </div>
    </div>
</body>

</html>

<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "https://63b401c1ea89e3e3db539072.mockapi.io/api/v1/";

    const gPRODUCT_COLS = [
        "stt",
        "productCode",
        "productName",
        "categoryId",
        "countryId",
        "imagUrl",
        "price",
        "discountPrice",
        "action",
    ];

    const gSTT_COL = 0;
    const gMASP_COL = 1;
    const gTENSP_COL = 2;
    const gNHOMSP_COL = 3;
    const gQUOC_GIA_COL = 4;
    const gANH_DAI_DIEN_COL = 5;
    const gGIA_BAN_COL = 6;
    const gGIA_GIAM_COL = 7;
    const gACTION_COL = 8;

    var gStt = 1;

    var gProductList = [];
    var gCountryList = [];
    var gCategoryList = [];

    gProductId = 0;

    var gFilterTable;
    var gProductTable = $("#san-pham-table").DataTable({
        columns: [
            { data: gPRODUCT_COLS[gSTT_COL] },
            { data: gPRODUCT_COLS[gMASP_COL] },
            { data: gPRODUCT_COLS[gTENSP_COL] },
            { data: gPRODUCT_COLS[gNHOMSP_COL] },
            { data: gPRODUCT_COLS[gQUOC_GIA_COL] },
            { data: gPRODUCT_COLS[gANH_DAI_DIEN_COL] },
            { data: gPRODUCT_COLS[gGIA_BAN_COL] },
            { data: gPRODUCT_COLS[gGIA_GIAM_COL] },
            { data: gPRODUCT_COLS[gACTION_COL] },
        ],
        info: false,
        paging: false,
        searching: false,
        ordering: false,
        columnDefs: [
            {
                targets: gSTT_COL,
                render: function () {
                    return gStt++;
                },
            },
            {
                targets: gNHOMSP_COL,
                render: renderCategoryIdToName,
            },
            {
                targets: gQUOC_GIA_COL,
                render: renderCountryIdToName,
            },
            {
                targets: gANH_DAI_DIEN_COL,
                render: function (data) {
                    return `
                        <img src="${data}" class="img-thumbnail" style="width: 7rem; height: 5rem;"/>
                    `;
                },
            },
            {
                targets: gACTION_COL,
                defaultContent: `
                    <img class="edit-product" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
                    <img class="delete-product" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
                `,
            },
        ],
    });
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    onPageLoading();
    $(document).on("click", ".edit-product", function () {
        onBtnEditClick(this);
    });
    $("#btn-filter").click(onBtnFilterProductClick);
    $(document).on("click", ".edit-filter-product", function () {
        onBtnEditClick(this);
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm thực thi khi tải trang
    function onPageLoading() {
        loadProductList();
        loadCountryList();
        loadCategoryList();

        loadModalCountryOptions();
        loadModalCategoryOptions();
    }

    //hàm thực thi khi nhấn nút icon Edit
    function onBtnEditClick(paramBtnElement) {
        gProductId = getProductId(paramBtnElement);
        getProductById(gProductId);
    }

    //hàm thực thi khi nhấn nút Lọc sản phẩm
    function onBtnFilterProductClick() {
        var vFilterObj = {
            country: "",
            category: "",
        };

        //B1: thu thập dữ liệu
        readData(vFilterObj);
        //B3: tìm kiếm và hiển thị dữ liệu
        var vFilteredProducts = findProductByFilter(vFilterObj);
        $("#san-pham-table").css("display", "none");
        //gProductTable.find("tr:gt(0)").html("");
        if (vFilteredProducts.length > 0) {
            alert("Tìm thấy " + vFilteredProducts.length + " kết quả phù hợp!")
            fillDataTableProduct(vFilteredProducts);
        } else {
            alert("Không tìm thấy kết quả phù hợp!");
            return false;
        }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm gọi api lấy list product
    function loadProductList() {
        $.ajax({
            url: gBASE_URL + "products/",
            type: "GET",
            dataType: "json",
            success: function (res) {
                console.log(res);
                gProductList = res;
                loadProductOnTable(res);
            },
            error: function (ajaxContext) {
                alert(ajaxContext.responseText);
            },
        });
    }

    //hàm load product lên table
    function loadProductOnTable(paramRes) {
        gProductTable.clear();
        gProductTable.rows.add(paramRes);
        gProductTable.draw();
    }

    //hàm gọi api lấy list country
    function loadCountryList() {
        $.ajax({
            url: gBASE_URL + "countries/",
            type: "GET",
            dataType: "json",
            async: false,
            success: function (res) {
                console.log(res);
                gCountryList = res;
                loadCountryOnSelect(res);
            },
            error: function (ajaxContext) {
                alert(ajaxContext.responseText);
            },
        });
    }

    //hàm hiển thị country lên ô select Quốc gia
    function loadCountryOnSelect(paramRes) {
        for (var bI = 0; bI < paramRes.length; bI++) {
            var bObject = paramRes[bI];

            $("#nuoc-select").append(
                `<option value="${bObject.id}">${bObject.countryName}</option>`
            );
        }
    }

    //hàm gọi api lấy list category
    function loadCategoryList() {
        $.ajax({
            url: gBASE_URL + "categories/",
            type: "GET",
            dataType: "json",
            async: false,
            success: function (res) {
                console.log(res);
                gCategoryList = res;
                loadCategoryOnSelect(res);
            },
            error: function (ajaxContext) {
                alert(ajaxContext.responseText);
            },
        });
    }

    //hàm hiển thị category lên select Nhóm sản phẩm
    function loadCategoryOnSelect(paramRes) {
        for (var bI = 0; bI < paramRes.length; bI++) {
            var bObject = paramRes[bI];

            $("#nhom-san-pham-select").append(
                `<option value="${bObject.id}">${bObject.categoryName}</option>`
            );
        }
    }

    //hàm render từ category id sang category name
    function renderCategoryIdToName(paramCategoryId) {
        var vCName = "Chưa phân nhóm";
        var vFound = false;
        var vIndex = 0;

        while (!vFound && vIndex < gCategoryList.length) {
            if (gCategoryList[vIndex].id == paramCategoryId) {
                vCName = gCategoryList[vIndex].categoryName;
                vFound = true;
            }
            vIndex++;
        }
        return vCName;
    }

    //hàm render từ country id sang country name
    function renderCountryIdToName(paramCountryId) {
        var vCoName = "Chưa có thông tin";
        var vFound = false;
        var vIndex = 0;

        while (!vFound && vIndex < gCountryList.length) {
            if (gCountryList[vIndex].id == paramCountryId) {
                vCoName = gCountryList[vIndex].countryName;
                vFound = true;
            }
            vIndex++;
        }
        return vCoName;
    }

    //hàm load country list vào select Quốc gia trên modal
    function loadModalCountryOptions() {
        for (var bI = 0; bI < gCountryList.length; bI++) {
            var bObject = gCountryList[bI];

            $("#select-edit-country").append(
                `<option value="${bObject.id}">${bObject.countryName}</option>`
            );
        }
    }

    //hàm load category list vào select Nhóm sản phẩm trên modal
    function loadModalCategoryOptions() {
        for (var bI = 0; bI < gCategoryList.length; bI++) {
            var bObject = gCategoryList[bI];

            $("#select-edit-category").append(
                `<option value="${bObject.id}">${bObject.categoryName}</option>`
            );
        }
    }

    //hàm lấy id product dựa vào nút đã ấn
    function getProductId(paramBtn) {
        var vRow = $(paramBtn).parents("tr");
        var vRowData;
        if($(paramBtn).attr("class") == "edit-filter-product") {
            vRowData = gFilterTable.row(vRow).data();
        } else {
            vRowData = gProductTable.row(vRow).data();
        }
        console.log($(paramBtn).attr("class"));
        return vRowData.id;
    }

    //hàm gọi api để lấy product qua id
    function getProductById(paramId) {
        $.ajax({
            url: gBASE_URL + "products/" + paramId,
            type: "GET",
            success: function (res) {
                console.log(res);
                showProductDataOnModal(res);
            },
            error: function (ajaxContext) {
                alert(ajaxContext.responseText);
            },
        });
        $("#edit-product-modal").modal("show");
    }

    //hàm hiển thị dữ liệu product đã chọn lên modal
    function showProductDataOnModal(paramRes) {
        $("#img-modal").attr("src", paramRes.imagUrl)
        $("#input-edit-img-url").val(paramRes.imagUrl);
        $("#input-edit-masp").val(paramRes.productCode);
        $("#input-edit-tensp").val(paramRes.productName);
        $("#input-edit-gia-ban").val(paramRes.price);
        $("#input-edit-gia-giam").val(paramRes.discountPrice);
        $("#select-edit-category").val(paramRes.categoryId);
        $("#select-edit-country").val(paramRes.countryId);
    }

    //hàm thu thập dữ liệu để lọc
    function readData(paramFilterObj) {
        var vCountry = $("#nuoc-select").val();
        var vCategory = $("#nhom-san-pham-select").val();

        paramFilterObj.country = vCountry;
        paramFilterObj.category = vCategory;
    }

    //hàm lọc dữ liệu
    function findProductByFilter(paramFilterObj) {
        var vProducts = [];

        if (paramFilterObj.country !== "0" && paramFilterObj.category !== "0") {
            for (let bI = 0; bI < gProductList.length; bI++) {
                const bProductObj = gProductList[bI];
                if (paramFilterObj.country === bProductObj.countryId &&
                    paramFilterObj.category === bProductObj.categoryId) {
                    vProducts.push(bProductObj);
                }
            }
        }

        if (paramFilterObj.country !== "0" && paramFilterObj.category === "0") {
            for (let bI = 0; bI < gProductList.length; bI++) {
                const bProductObj = gProductList[bI];
                if (paramFilterObj.country === bProductObj.countryId) {
                    vProducts.push(bProductObj);
                }
            }
        }

        if (paramFilterObj.country === "0" && paramFilterObj.category !== "0") {
            for (let bI = 0; bI < gProductList.length; bI++) {
                const bProductObj = gProductList[bI];
                if (paramFilterObj.category === bProductObj.categoryId) {
                    vProducts.push(bProductObj);
                }
            }
        }

        return vProducts;
    }

    //hàm hiển thị kết quả lọc lên table
    function fillDataTableProduct(paramFilteredProducts) {
        $("#filter-table").css("display", "block");
        gFilterTable = $("#filter-table").DataTable({
            data: paramFilteredProducts,
            columns: [
                { data: gPRODUCT_COLS[gSTT_COL] },
                { data: gPRODUCT_COLS[gMASP_COL] },
                { data: gPRODUCT_COLS[gTENSP_COL] },
                { data: gPRODUCT_COLS[gNHOMSP_COL] },
                { data: gPRODUCT_COLS[gQUOC_GIA_COL] },
                { data: gPRODUCT_COLS[gANH_DAI_DIEN_COL] },
                { data: gPRODUCT_COLS[gGIA_BAN_COL] },
                { data: gPRODUCT_COLS[gGIA_GIAM_COL] },
                { data: gPRODUCT_COLS[gACTION_COL] },
            ],
            paging: false,
            searching: false,
            ordering: false,
            columnDefs: [
                {
                    targets: gSTT_COL,
                    render: function () {
                        return gStt++;
                    },
                },
                {
                    targets: gNHOMSP_COL,
                    render: renderCategoryIdToName,
                },
                {
                    targets: gQUOC_GIA_COL,
                    render: renderCountryIdToName,
                },
                {
                    targets: gANH_DAI_DIEN_COL,
                    render: function (data) {
                        return `
                        <img src="${data}" class="img-thumbnail" style="width: 7rem; height: 5rem;"/>
                    `;
                    },
                },
                {
                    targets: gACTION_COL,
                    defaultContent: `
                    <img class="edit-filter-product" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
                    <img class="delete-filter-product" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
                `,
                },
            ],
        });
    }
</script>